/*------------------------------------------------------------------------------
--  This file is a part of the libuc, microcontroler library
--  Copyright (C) 2011, Alexis Jeandet
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
-------------------------------------------------------------------------------
--                 Author : Alexis Jeandet
--                   Mail : alexis.jeandet@gmail.com
-------------------------------------------------------------------------------*/
#ifndef UART_H
#define UART_H

#include "LPC23xx.h"
#include <uhandle.h>


#define uartNoParity 0
#define uartOddParity 1
#define uartEvenParity 3
#define uartTrueParity 5
#define uartFalseParity 7

struct LPC17XXuartRegs
{
 unsigned long RWreg;
 unsigned long IntEN;
 unsigned long IntIdFIFOctrlr;
 unsigned long LineCtrl;
 unsigned long dummy;
 unsigned long LineStat;
 unsigned long ScratchPad;
};

typedef volatile struct LPC17XXuartRegs* _uartDev;
typedef UHANDLE uartDev;

extern uartDev uartopen(int count);
extern void uarton(int count);
extern void uartoff(int count);
extern void uartputc(uartDev dev,char c);
extern void uartputs(uartDev dev,char *s);
extern void uartgets(uartDev dev,char *s);
extern char uartgetc(uartDev dev);
extern void uartsetbaudrate(uartDev dev,unsigned int  baudRate);
extern unsigned char uartgetpclkfactor(uartDev dev);
extern void uartsetpclkfactor(uartDev dev,unsigned char pclkfactor);
extern void uartsetup(uartDev dev,unsigned int  baudRate,unsigned char WordLength,unsigned char StopBitCnt,unsigned char Parity);

#endif








